﻿//////////////////////////////////////////////
// CameraWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	class DLL_ASTRAEUS_EXPORT CameraWrapper final
	{
		private :

			// Constructeur, destructeur
			CameraWrapper () = delete ;
			~CameraWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Getters
			static nkScripts::OutputValue getPositionAbsolute (void* data) ;
			static nkScripts::OutputValue getFrustum (void* data) ;
			static nkScripts::OutputValue getFov (void* data) ;
	} ;
}