﻿//////////////////////////////////////////////
// LightManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Light ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMaths
#include <NilkinsMaths/Algebra/Vector.h>

// Standards
#include <map>
#include <string>

/// Class ------------------------------------

namespace nkGraphics
{	
	class DLL_GRAPHICS_EXPORT LightManager : public nkCommon::SingletonClass<LightManager>
	{
		friend class nkCommon::SingletonClass<LightManager> ;

		private :
		
			// Attributs
			// Liste des lumières
			std::map<std::string, Light*> _lightMap ;

			// La lumière ambient
			nkMaths::Vector _ambientComponent ;

		private :

			// Functions
			// Constructeur
			LightManager () ;
		
		public :

			// Destructeur
			~LightManager () ;

			// Ajout de lumière
			Light* createLight (const char* lightNameStr) ;

			// Getters
			Light* getLight (const char* lightNameStr) ;
			nkMaths::Vector getAmbient () const ;

			// Setters
			void setAmbient (const nkMaths::Vector& color) ;
	} ;
}