﻿//////////////////////////////////////////////
// PostProcessPass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class BlendState ;
	class Camera ;
	class Shader ;
}

/// Includes ---------------------------------

// nkGraphics
#include "Pass.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT PostProcessPass : public Pass
	{
		protected :		
		
			// Attributs
			// Le shader à utiliser
			Shader* _processShader ;
			// Si nous sommes ou pas post process ou back render
			bool _backProcess ;

			// Blend State
			BlendState* _blendState ;

			// Camera si besoin est
			Camera* _linkedCam ;

		protected :

			// Constructor, destructor
			PostProcessPass () ;
			virtual ~PostProcessPass () ;
		
		public :

			// Getters
			Shader* getAttachedShader () const ;
			bool isBackProcessPass () const ;
			BlendState* getBlendState () const ;
			Camera* getLinkedCam () const ;

			// Setters
			void setProcessShader (Shader* shade) ;
			virtual void setBackProcess (bool value) ;
			virtual void setBlendState (BlendState* state) ;
			void setLinkedCam (Camera* cam) ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}