﻿//////////////////////////////////////////////
// Quaternion.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkMaths
{
	class Matrix ;
}

/// Includes ---------------------------------

// nkGraphics
#include "Vector.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkMaths
{
	class DLL_MATHS_EXPORT Quaternion : public Vector
	{
		public :
		
			// Constructeur, destructeur
			Quaternion () ;
			Quaternion (float a, float b, float c, float w) ;
			Quaternion (const Vector& axis, float angle) ;
			Quaternion (const Vector& eulerAngles) ;
			Quaternion (const Matrix& mat) ;
			Quaternion (const Quaternion& other) ;
			Quaternion (const DirectX::XMVECTOR& value) ;
			~Quaternion () ;

			// Pratique
			Vector getAsEulerAngles () const ;

			void setFromAxisAngle (const Vector& axis, float angle) ;
			void setFromEuler (const Vector& angles) ;
			void setFromMatrix (const Matrix& mat) ;

			// Opérateurs
			// Egalité
			Quaternion& operator= (const Quaternion& other) ;
			// Multiplication entre Quaternion
			Quaternion operator* (const Quaternion& other) const ;
			void operator*= (const Quaternion& other) ;
	} ;
}