﻿//////////////////////////////////////////////
// Function.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class UserType ;
}

/// Includes ---------------------------------

// nkScripts
#include "../../Dll/DllDefines.h"

#include "FunctionDefines.h"
#include "FunctionParameter.h"

// Standards
#include <string>
#include <vector>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT Function
	{
		protected :

			// Attributes
			// Nom
			std::string _name ;

			// Paramètres
			std::vector<FunctionParameter> _parameters ;

			// Function à utiliser
			FunctionCallback _function ;

		public :

			// Fonction par défaut
			OutputValue defaultFunction (const DataStack& stack) ;

		public :

			// Constructeur, destructeur
			Function (const char* name) ;
			virtual ~Function () ;

			// Getters
			const char* getName () const ;

			// Ajout de paramètre à déclarer
			void addParameter (FUNCTION_PARAMETER_TYPE type, const char* userTypeName = "") ;

			// Set de la fonction
			void setFunction (FunctionCallback function) ;

			// Reset de l'état
			void reset () ;
	} ;
}