﻿//////////////////////////////////////////////
// Namespace.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Function ;
	class UserType ;
}

/// Includes ---------------------------------

// nkScripts
#include "../../Dll/DllDefines.h"

// Standards
#include <string>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT Namespace
	{
		protected :

			// Nom interne
			std::string _name ;

		public :

			// Constructeur, destructeur
			Namespace (const char* name) ;
			virtual ~Namespace () ;

			// Getters
			const char* getName () const ;

			// Constrôles : Getters
			virtual Namespace* getNamespace (const char* name) const = 0 ;
			virtual UserType* getUserType (const char* name) const = 0 ;

			// Contrôles : Setters
			virtual void setVar (const char* name, int value) = 0 ;
			virtual void setObject (const char* name, const char* userTypeName, void* value) = 0 ;

			virtual Namespace* setNamespace (const char* name) = 0 ;
			virtual UserType* setUserType (const char* name) = 0 ;
			virtual Function* setFunc (const char* name) = 0 ;

			virtual void shutdown () = 0 ;
			virtual void reset () = 0 ;
	} ;
}