﻿//////////////////////////////////////////////
// ContextMenu.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Component ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

// Standards
#include <functional>
#include <vector>

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT ContextMenu : public nkExport::Exportable
	{
		protected :
		
			// Fenêtre parente
			Component* _parentWin ;

			// Les callbacks suivant les codes
			std::vector<std::function<void(ContextMenu*)>> _callbacks ;
			
		public :
		
			// Constructeur, destructeur
			ContextMenu () ;
			virtual ~ContextMenu () ;

			// Getters
			Component* getParentComponent () const ;

			// Setters
			void setParentComponent (Component* parent) ;

			// Création contenu
			//virtual void addItem (const char* itemLabel, const std::function<void(ContextMenu*)>& callback) ;
			virtual void addItem (const char* itemLabel, int attachedIndex) = 0 ;
			virtual void addSeparator () = 0 ;

			// Vue
			virtual int showMenu (int absX, int absY) = 0 ;

			// Import / Export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}