﻿//////////////////////////////////////////////
// Popup.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Window.h"

#include "../Dll/DllDefines.h"

/// Internals --------------------------------

namespace nkWinUi
{
	// Les popup possibles
	enum class POPUP_TYPE
	{
		POPUP_TYPE_OK = 0,
		POPUP_TYPE_OK_CANCEL,
		POPUP_TYPE_ABORT_RETRY_IGNORE,
		POPUP_TYPE_YES_NO_CANCEL,
		POPUP_TYPE_YES_NO,
		POPUP_TYPE_RETRY_CANCEL,
		POPUP_TYPE_CANCEL_TRY_CONTINUE,
		POPUP_TYPE_HELP = 0x4000L
	} ;

	// Les retours possibles
	enum class POPUP_RESULT
	{
		POPUP_RESULT_UNKNOWN = 0,
		POPUP_RESULT_OK,
		POPUP_RESULT_CANCEL,
		POPUP_RESULT_ABORT,
		POPUP_RESULT_RETRY,
		POPUP_RESULT_IGNORE,
		POPUP_RESULT_YES,
		POPUP_RESULT_NO,
		POPUP_RESULT_TRY_AGAIN = 10,
		POPUP_RESULT_CONTINUE
	} ;
}

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT Popup : public Window
	{
		public :
		
			// Constructeur, destructeur
			Popup () ;
			~Popup () ;

			// Override
			virtual void setParentComponent (Component* parent, bool makeItVisible = true) override ;

			// Pop sur l'écran en utilisant la fenêtre active
			virtual void pop () ;
			virtual void unpop () ;

			// Pop sur l'écran (version statique simple)
			static POPUP_RESULT pop (POPUP_TYPE type, const char* title, const char* message, Component* parent) ;
	} ;
}