﻿//////////////////////////////////////////////
// Static.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"
	
/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Static : public Component
	{
		public :
				
			enum class ALIGNMENT
			{
				LEFT = 0,
				CENTER,
				RIGHT
			} ;

		protected :
		
			// Attributs
			// Pour le style
			ALIGNMENT _align ;
		
		public :
		
			// Constructeur, destructeur
			Static () ;
			~Static () ;

			// Getters
			ALIGNMENT getAlign () const ;

			// Setters
			virtual void setAlign (ALIGNMENT value) ;

			// Pratiques
			const char* alignToString (ALIGNMENT toConvert) ;
			ALIGNMENT stringToAlign (const std::string_view& toConvert) ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}